CREATE TABLE IF NOT EXISTS `[#DB_PREFIX#]users_weixin` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NOT NULL,
  `openid` varchar(255) NOT NULL,
  `expires_in` int(10) NOT NULL,
  `access_token` varchar(255) NOT NULL,
  `refresh_token` varchar(255) NOT NULL,
  `scope` varchar(64) NOT NULL,
  `headimgurl` varchar(255) NOT NULL,
  `nickname` varchar(64) NOT NULL,
  `sex` tinyint(1) NOT NULL DEFAULT '0',
  `province` varchar(32) NOT NULL,
  `city` varchar(32) NOT NULL,
  `country` varchar(32) NOT NULL,
  `add_time` int(10) NOT NULL,
  `latitude` float DEFAULT NULL,
  `longitude` float DEFAULT NULL,
  `location_update` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uid` (`uid`),
  KEY `openid` (`openid`),
  KEY `expires_in` (`expires_in`),
  KEY `scope` (`scope`),
  KEY `sex` (`sex`),
  KEY `province` (`province`),
  KEY `city` (`city`),
  KEY `country` (`country`),
  KEY `add_time` (`add_time`),
  KEY `geo_location` (`latitude`,`longitude`),
  KEY `location_update` (`location_update`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;


DROP TABLE `[#DB_PREFIX#]weixin_valid`;
DROP TABLE `[#DB_PREFIX#]weixin_fake_id`;
DROP TABLE `[#DB_PREFIX#]weixin_publish_rule`;


CREATE TABLE IF NOT EXISTS `[#DB_PREFIX#]geo_location` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `item_type` varchar(32) NOT NULL,
  `item_id` int(10) NOT NULL,
  `latitude` float NOT NULL,
  `longitude` float NOT NULL,
  `add_time` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `item_type` (`item_type`),
  KEY `add_time` (`add_time`),
  KEY `geo_location` (`latitude`,`longitude`),
  KEY `item_id` (`item_id`)
) ENGINE=[#DB_ENGINE#] DEFAULT CHARSET=utf8;


ALTER TABLE `[#DB_PREFIX#]users` DROP `weixin_id`;
ALTER TABLE `[#DB_PREFIX#]weixin_reply_rule` DROP `event_key`;
ALTER TABLE `[#DB_PREFIX#]users` ADD `weixin_settings` VARCHAR( 255 ) NULL;
